/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/
namespace IRDB_SDK
{
	class AddressID_t : virtual public BaseObj_t
	{
		protected:
			AddressID_t() {}
			AddressID_t(const AddressID_t& copy)=delete;

		public:
			virtual ~AddressID_t() {}

			virtual DatabaseID_t    getFileID()        const = 0;
			virtual VirtualOffset_t getVirtualOffset() const = 0;

			virtual void setFileID(DatabaseID_t thefileID)      = 0;
			virtual void setVirtualOffset(VirtualOffset_t voff) = 0;
	};

}
