/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{
	using namespace std;

	class IRDBObjects_t
	{
		protected:
			IRDBObjects_t() {}
			IRDBObjects_t(const IRDBObjects_t& copy) = delete;
		public:
			virtual ~IRDBObjects_t() {}
			virtual FileIR_t*    addFileIR(const DatabaseID_t variant_id, const DatabaseID_t file_id)               = 0;
			virtual void         deleteFileIR(const DatabaseID_t file_id)                                           = 0;
			virtual VariantID_t* addVariant(const DatabaseID_t variant_id)                                          = 0;
			virtual void         deleteVariant(DatabaseID_t variant_id)                                             = 0;
			virtual pqxxDB_t*    getDBInterface() const                                                             = 0;
			virtual pqxxDB_t*    resetDBInterface()                                                                 = 0;
			virtual int          writeBackFileIR(const DatabaseID_t file_id, ostream *verbose_logging=nullptr)      = 0;
			virtual int          writeBackVariant(const DatabaseID_t variant_id)                                    = 0;
			virtual int          writeBackAll(ostream* verbose_logging=nullptr)                                     = 0;
			virtual void         deleteAll(void)                                                                    = 0;
			virtual void         tidyIR()                                                                           = 0;
	};

}

 
