/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{
	using namespace std;

	class Relocation_t : virtual public BaseObj_t
	{
		protected:
			Relocation_t() { }
			Relocation_t(const Relocation_t& copy) = delete;
		
		public:
			virtual ~Relocation_t() { }

			virtual int        getOffset() const = 0;
			virtual string     getType()   const = 0;
			virtual uint32_t   getAddend() const = 0;
			virtual BaseObj_t* getWRT()    const = 0;

			virtual void setOffset(int off)              = 0;
			virtual void setType(string ty)              = 0;
			virtual void setAddend(uint32_t p_addend)    = 0;
			virtual void setWRT(BaseObj_t* WRT)          = 0;

	};
}
