/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{

	using namespace std;

	class VariantID_t : virtual public BaseObj_t
	{

		protected:
			VariantID_t() { }

		public:
			virtual ~VariantID_t() { }

			virtual bool                isRegistered()         const = 0;
			virtual const FileSet_t&    getFiles()             const = 0; 
			virtual File_t*             getMainFile()          const = 0;
			virtual DatabaseID_t        getOriginalVariantID() const = 0; 
			virtual string              getName()              const = 0;



			virtual bool registerID()            = 0;
			virtual void setName(string newname) = 0; 
			virtual VariantID_t* clone(bool deep=true) = 0;

		// factories:
			static unique_ptr<VariantID_t> factory(const DatabaseID_t& id);
			

	};

	ostream& operator<<(ostream& out, const VariantID_t& pid);

}

